﻿using UnityEngine;
using System.Collections;

public class EnemyAI : MonoBehaviour {

    public DecisionTree root = new DecisionTree();
    public Transform target;
    private Rigidbody2D Enemy;
    private Animator myAnimator;
    private bool LookRight = false;
    public bool set;
    private float speed = 1;


    void Start() {
        //  Debug.Log("start");
        target = GameObject.Find("Player").transform; //look at the player
        myAnimator = GetComponent<Animator>(); //required for animation *******
        Enemy = GetComponent<Rigidbody2D>();
    }

    void Update() {
        BuildDecisionTree();
        root.search(root);

    }

    public bool inAttackRange() {

        if (Vector3.Distance(transform.position, target.position) < 1f) {
                Debug.Log("In Zone");
            return true;
        }
        else {
            // Debug.Log("In Zone- not");
            return false;

        }

    }

    public bool moveToEnemy() {
        //  Debug.Log("range");
        if (Vector3.Distance(transform.position, target.position) > 2) {
            myAnimator.SetBool("speed", true);
            return true;
        }
        else {
            return false;
        }
    }

    public bool isPlayerAttacking() {
        if (Input.GetKeyDown(KeyCode.Space)) {
            return true;
        }
        return false;
    }

    /*
    public bool hpLevel() {
        //   Debug.Log("hp");
        if (EnemyDamage.health <= 2) {
            return false;
        }
        else {
            return true;
        }
    }
    */

    public void attack() {
        Debug.Log("attacking");
        myAnimator.SetBool("speed", false);
        myAnimator.SetBool("attack", true);
    }


    public void run() {
        float option = Random.Range(0, 2);
        if (option == 1) {
            myAnimator.SetBool("block", true);
            Enemy.velocity = Vector2.zero;
        }

        if (option == 2) {
            Enemy.AddForce(new Vector2(-50, 500));
        }
    }

    public void moveToPlayer() {
        //  Debug.Log("attacking");
        //rotate to look at the player
        //transform.LookAt(target.position);
        myAnimator.SetBool("speed", true);
        transform.position = Vector2.MoveTowards(transform.position, target.position, speed * Time.deltaTime);

        if (target.transform.position.x <= transform.position.x) //players spot in world space as opposed to enemy "self" spot 
        {
            transform.rotation = new Quaternion(0, 180, 0, 0); // flips enemy around to face the player on x axis only
        }
        else if (target.transform.position.x >= transform.position.x) //players spot in world space as opposed to enemy "self" spot
        {
            transform.rotation = new Quaternion(0, 0, 0, 0); // flips enemy around to face the player on x axis only }
        }



    }

    public void BuildDecisionTree() {


        //Left SubTree
        DecisionTree Run = new DecisionTree();
        Run.setAction(run);

        DecisionTree MoveToPlayer = new DecisionTree();
        MoveToPlayer.setAction(moveToPlayer);

        DecisionTree Attack = new DecisionTree();
        MoveToPlayer.setAction(attack);



        /*
        DecisionTree HpLevel = new DecisionTree();
        HpLevel.setDecision(hpLevel);
        HpLevel.setLeft(Attack);
        HpLevel.setRight(Retreat);
        */

        DecisionTree GettingAttacked = new DecisionTree();
        GettingAttacked.setDecision(isPlayerAttacking);
        GettingAttacked.setLeft(Run);
        GettingAttacked.setRight(Attack);

        //Right Subtree
        root.setDecision(inAttackRange);
        root.setLeft(GettingAttacked);
        root.setRight(MoveToPlayer);

    }


}
